// Range stop & reverse.mq4
//  "   "
// .   1  1.  EURUSD   Range=35, 
// GBPUSD   Range=65.       
// ().          .
#property copyright "mandorr@gmail.com"
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Violet
#property indicator_color2 SkyBlue
#property indicator_color3 Silver

extern int Range=35;          //   
extern int CountBars=10000;   //   

double buffer0[];
double buffer1[];
double buffer2[];

void init() {
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(0,buffer0);
   SetIndexLabel(0," ");
   SetIndexDrawBegin(0,0);

   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(1,buffer1);
   SetIndexLabel(1," ");
   SetIndexDrawBegin(1,0);

   SetIndexStyle(2,DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(2,buffer2);
   SetIndexLabel(2,"");
   SetIndexDrawBegin(2,0);

   IndicatorShortName("    ("+Range+" )");
}

void deinit() {
   Comment("");
}

void start() {
   int dir, dir1, i;
   double h, l, h1, l1;
   h=(High[CountBars]+Low[CountBars]+Range*Point)/2;
   l=(High[CountBars]+Low[CountBars]-Range*Point)/2;
   dir=0;
   for (i=CountBars-1; i>=0; i--) {
      h1=h;
      l1=l;
      dir1=dir;
      if (High[i]>h) {h=High[i]; l=h-Range*Point;}
      if (Low [i]<l) {l=Low [i]; h=l+Range*Point;}
      if (h>h1) dir =1;
      if (l<l1) dir=-1;
      if (h>h1 && l<l1) dir=0;
      buffer0[i]=EMPTY_VALUE;
      buffer1[i]=EMPTY_VALUE;
      if (dir<0) buffer0[i]=h;
      if (dir>0) buffer1[i]=l;
      if (dir1<0 && dir>0) buffer0[i]=h1;
      if (dir1>0 && dir<0) buffer1[i]=l1;
      buffer2[i]=(h+l)/2;
   }
   if (buffer0[0]!=EMPTY_VALUE) Comment("SELL,     "+DoubleToStr(buffer0[0],Digits));
   if (buffer1[0]!=EMPTY_VALUE) Comment("BUY,     "+DoubleToStr(buffer1[0],Digits));
}


